package cofh.thermal.expansion.compat.jei.machine;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import cofh.lib.util.helpers.StringHelper;
import cofh.thermal.core.ThermalCore;
import cofh.thermal.core.compat.jei.TCoreJeiPlugin;
import cofh.thermal.core.util.recipes.machine.FurnaceRecipe;
import cofh.thermal.expansion.client.gui.machine.MachineFurnaceScreen;
import cofh.thermal.lib.compat.jei.Drawables;
import cofh.thermal.lib.compat.jei.ThermalRecipeCategory;
import cofh.thermal.lib.util.recipes.ThermalRecipe;
import com.mojang.blaze3d.vertex.PoseStack;
import java.util.List;
import mezz.jei.api.gui.builder.IRecipeLayoutBuilder;
import mezz.jei.api.gui.builder.IRecipeSlotBuilder;
import mezz.jei.api.gui.drawable.IDrawable;
import mezz.jei.api.gui.drawable.IDrawableAnimated;
import mezz.jei.api.gui.ingredient.IRecipeSlotsView;
import mezz.jei.api.helpers.IGuiHelper;
import mezz.jei.api.recipe.IFocusGroup;
import mezz.jei.api.recipe.RecipeIngredientRole;
import net.minecraft.network.chat.Component;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.level.block.Block;

public class FurnaceRecipeCategory extends ThermalRecipeCategory<FurnaceRecipe> {
  public FurnaceRecipeCategory(IGuiHelper guiHelper, ItemStack icon, ResourceLocation uid) {
    super(guiHelper, icon, uid);
    this
      
      .background = (IDrawable)guiHelper.drawableBuilder(MachineFurnaceScreen.TEXTURE, 26, 11, 124, 62).addPadding(0, 0, 16, 24).build();
    this.name = (Component)StringHelper.getTextComponent(((Block)ThermalCore.BLOCKS.get("machine_furnace")).m_7705_());
    this.progressBackground = Drawables.getDrawables(guiHelper).getProgress(0);
    this.speedBackground = Drawables.getDrawables(guiHelper).getScale(4);
    this.progress = guiHelper.createAnimatedDrawable(Drawables.getDrawables(guiHelper).getProgressFill(0), 200, IDrawableAnimated.StartDirection.LEFT, false);
    this.speed = guiHelper.createAnimatedDrawable(Drawables.getDrawables(guiHelper).getScaleFill(4), 400, IDrawableAnimated.StartDirection.TOP, true);
  }
  
  public Class<? extends FurnaceRecipe> getRecipeClass() {
    return FurnaceRecipe.class;
  }
  
  public void setRecipe(IRecipeLayoutBuilder builder, FurnaceRecipe recipe, IFocusGroup focuses) {
    List<Ingredient> inputs = recipe.getInputItems();
    List<ItemStack> outputs = recipe.getOutputItems();
    builder.addSlot(RecipeIngredientRole.INPUT, 43, 15)
      .addIngredients(inputs.get(0));
    ((IRecipeSlotBuilder)builder.addSlot(RecipeIngredientRole.OUTPUT, 106, 24)
      .addItemStack(outputs.get(0)))
      .addTooltipCallback(TCoreJeiPlugin.defaultOutputTooltip(((Float)recipe.getOutputItemChances().get(0)).floatValue()));
  }
  
  public void draw(FurnaceRecipe recipe, IRecipeSlotsView recipeSlotsView, PoseStack matrixStack, double mouseX, double mouseY) {
    super.draw((ThermalRecipe)recipe, recipeSlotsView, matrixStack, mouseX, mouseY);
    this.progressBackground.draw(matrixStack, 69, 24);
    this.speedBackground.draw(matrixStack, 43, 33);
    this.progress.draw(matrixStack, 69, 24);
    this.speed.draw(matrixStack, 43, 33);
  }
}
